import { ErrorEvent, CloseEvent } from 'reconnecting-websocket';
import { Doc } from 'sharedb/lib/client';
import { DocBlock, DocBlockDelta, DocObject } from '@nexteditorjs/nexteditor-core';
import { ClientError, ErrorType, ShareDBDocOptions, ShareDBError } from './options';
export interface ShareDBDocClientEvent {
    onSubscribe: () => void;
    onOp: (ops: any[], source: any, clientId: string) => void;
    onError: (errorType: ErrorType, error: ClientError) => void;
    onClose: (event: CloseEvent) => void;
}
export default class ShareDBDocClient {
    private options;
    private events;
    private socket;
    private connection;
    doc: Doc;
    constructor(options: ShareDBDocOptions, events: ShareDBDocClientEvent);
    get data(): any;
    destroy(): void;
    handleSubscribe: (error: ShareDBError | undefined) => void;
    handleSocketError: (error: ErrorEvent) => void;
    handleSocketClose: (event: CloseEvent) => void;
    submitOp: (ops: any) => Promise<void>;
    createDoc: (data: DocObject) => Promise<void>;
    insertChildContainer: (containerId: string, blocks: DocBlock[]) => Promise<void>;
    deleteChildContainer: (containerId: string) => Promise<void>;
    insertBlock: (containerId: string, index: number, obj: unknown) => Promise<void>;
    deleteBlock: (containerId: string, index: number) => Promise<void>;
    updateBlockData: (containerId: string, index: number, delta: DocBlockDelta) => Promise<void>;
    updateRichText: (containerId: string, index: number, ops: any[]) => Promise<void>;
}
